BilbaoReader
Date: 2019-10-22

org.jmol.adapter.readers.xtal

## Class BilbaoReader

- java.lang.Object
- - org.jmol.adapter.smarter.AtomSetCollectionReader
  - - org.jmol.adapter.readers.xtal.BilbaoReader

- All Implemented Interfaces:
    javajs.api.GenericLineReader

      public class BilbaoReader
      extends AtomSetCollectionReader

  Bilbao Crystallographic Database file reader see, for example, http://www.cryst.ehu.es/cryst/compstru.html Comparison of Crystal Structures with the same Symmetry Note that this reader scrapes HTML. Keys for Bilbao format data are a given bit of text such as "High symmetry structure". Any changes to that (including capitalization) will cause this reader to fail. The space group number is read immediately after the "pre" tag on that line. filter options include: HIGH include high-symmetry structure; preliminary only
  Author:
    Bob Hanson

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private boolean` | `doDisplace`
    `private boolean` | `getHigh`
    `private boolean` | `getSym`
    `private int` | `i0`
    `private boolean` | `isBCSfile`
    `private java.lang.String` | `kvec`
    `private int` | `nAtoms`
    `private boolean` | `normDispl`

    - ### Fields inherited from class org.jmol.adapter.smarter.AtomSetCollectionReader

      `addedData, addedDataKey, addVibrations, allowPDBFilter, ANGSTROMS_PER_BOHR, applySymmetryToBonds, asc, baseAtomIndex, binaryDoc, bsFilter, bsModels, calculationType, continuing, debugging, desiredModelNumber, desiredSpaceGroupIndex, desiredVibrationNumber, doApplySymmetry, doCentralize, doCheckUnitCell, doConvertToFractional, doPackUnitCell, doProcessLines, doReadMolecularOrbitals, dssr, fileName, fileOffset, filePath, fileScaling, fillRange, filter, filterHetero, fixJavaFloat, forcePacked, getHeader, haveAtomFilter, haveModel, havePartialChargeFilter, htParams, ignoreFileSpaceGroupName, ignoreFileSymmetryOperators, ignoreFileUnitCell, ignoreStructure, iHaveFractionalCoordinates, iHaveSymmetryOperators, iHaveUnitCell, isBinary, isConcatenated, isDSSP1, isFinalized, isMolecular, isPrimitive, isSequential, isTrajectory, latticeCells, latticeScaling, latticeType, line, lstNCS, matUnitCellOrientation, modDim, modelNumber, ms, mustFinalizeModelSet, next, out, packingError, prevline, primitiveToCrystal, ptLine, ptSupercell, reader, readerName, requiresBSFilter, reverseModels, rotateHexCell, sgName, stateScriptVersionInt, strSupercell, symmetry, templateAtomCount, thisBiomolecule, trajectorySteps, unitCellOffset, unitCellParams, useAltNames, useFileModelNumbers, validation, vibrationNumber, vibsFractional, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BilbaoReader()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private boolean` | `checkComment()`
    `protected boolean` | `checkLine()`
    `private java.lang.String` | `getAttr(java.lang.String s, java.lang.String key)`
    `private java.lang.String` | `getLinesUntil(java.lang.String key)`
    `void` | `initializeReader()`
    `private java.lang.String` | `rdLine()`
    `private void` | `readBilbaoDataFile()`
    `private void` | `readBilbaoFormat(java.lang.String title, float fAmp)`
    `private void` | `readDisplacements(float fAmp)`
    `private void` | `readVirtual()`
    `private void` | `setTitle(java.lang.String title)`

    - ### Methods inherited from class org.jmol.adapter.smarter.AtomSetCollectionReader

      `addAtomXYZSymName, addExplicitLatticeVector, addJmolScript, addSites, addSiteScript, appendLoadNote, appendUunitCellInfo, applySymmetryAndSetTrajectory, applySymTrajASCR, checkCurrentLineForScript, checkFilterKey, checkLastModel, checkLineForScript, clearUnitCell, cloneLastAtomSet, discardLinesUntilBlank, discardLinesUntilContains, discardLinesUntilContains2, discardLinesUntilNonBlank, discardLinesUntilStartsWith, discardPreviousAtoms, doGetModel, doGetVibration, doPreSymmetry, fill3x3, fillDataBlock, fillDataBlockFixed, fillFloatArray, fillFrequencyData, filterAtom, filterReject, finalizeMOData, finalizeModelSet, finalizeReaderASCR, finalizeSubclassReader, finalizeSubclassSymmetry, forceSymmetry, fractionalizeCoordinates, getElementSymbol, getFilter, getFortranFormatLengths, getInterface, getNewSymmetry, getStrings, getSymmetry, getTokens, getTokensFloat, initializeSymmetry, initializeSymmetryOptions, initializeTrajectoryFile, isLastModel, newAtomSet, parseFloat, parseFloatRange, parseFloatStr, parseInt, parseIntAt, parseIntRange, parseIntStr, parseToken, parseTokenNext, parseTokenRange, parseTokenStr, processBinaryDocument, processDOM, rd, read3Vectors, readDataObject, readLines, readNextLine, rejectAtomName, RL, set2D, setAtomCoord, setAtomCoordScaled, setAtomCoordTokens, setAtomCoordXYZ, setChainID, setElementAndIsotope, setFilter, setFilterAtomTypeStr, setFractionalCoordinates, setIsPDB, setLoadNote, setModelPDB, setSpaceGroupName, setSymmetryOperator, setTransform, setUnitCell, setUnitCellItem, setup, setupASCR`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### getHigh

          private boolean getHigh

    - #### getSym

          private boolean getSym

    - #### normDispl

          private boolean normDispl

    - #### doDisplace

          private boolean doDisplace

    - #### kvec

          private java.lang.String kvec

    - #### i0

          private int i0

    - #### nAtoms

          private int nAtoms

    - #### isBCSfile

          private boolean isBCSfile

  - ### Constructor Detail

    - #### BilbaoReader

          public BilbaoReader()

  - ### Method Detail

    - #### initializeReader

          public void initializeReader()
                                throws java.lang.Exception

      Overrides:
        `initializeReader` in class `AtomSetCollectionReader`
      Throws:
        `java.lang.Exception`

    - #### checkLine

          protected boolean checkLine()
                               throws java.lang.Exception

      Overrides:
        `checkLine` in class `AtomSetCollectionReader`
      Returns:
        true if need to read new line
      Throws:
        `java.lang.Exception`

    - #### readBilbaoDataFile

          private void readBilbaoDataFile()
                                   throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### checkComment

          private boolean checkComment()

    - #### readBilbaoFormat

          private void readBilbaoFormat(java.lang.String title,
                                        float fAmp)
                                 throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### readDisplacements

          private void readDisplacements(float fAmp)
                                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### setTitle

          private void setTitle(java.lang.String title)

    - #### rdLine

          private java.lang.String rdLine()
                                   throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### readVirtual

          private void readVirtual()
                            throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getAttr

          private java.lang.String getAttr(java.lang.String s,
                                           java.lang.String key)

    - #### getLinesUntil

          private java.lang.String getLinesUntil(java.lang.String key)
                                          throws java.lang.Exception

      Throws:
        `java.lang.Exception`